//----------------------------
// CW framework <ccontrol.cpp>
//
// (Released under the terms
// of the GNU General Public
// License.)
//
// author:  Michael Hansen
// initiated: February 1998
//----------------------------

#include "Deskwin.h"

//////////////////////////////////////////////////////////////
//
// CComboBox
//
void CComboBox::InitMsgHandlers()
{
	// initialize message handlers
	AddMsg(SWinMsg(WM_COMPAREITEM, (CWMSGHANDLER)CComboBox::OnCompareItem));
	AddMsg(SWinMsg(WM_DELETEITEM, (CWMSGHANDLER)CComboBox::OnDeleteItem));
	AddMsg(SWinMsg(WM_DRAWITEM, (CWMSGHANDLER)CComboBox::OnDrawItem));
	AddMsg(SWinMsg(WM_MEASUREITEM, (CWMSGHANDLER)CComboBox::OnMeasureItem));
}

bool CComboBox::Create(int x, int y, int nWidth, int nHeight, int nID, DWORD dwStyle)
{
	bool oRetVal = CWindow::Create(_TEXT("combobox"), x, y, nWidth, nHeight, nID, dwStyle);
	// subclass edit child window to spy on messages by default
	if(oRetVal)
	{
		HWND hEdit = GetWindow(GW_CHILD);
		if(hEdit)
		{
			CWindow *pWindow;
			AddNewCW(pWindow, this, hEdit);
		}
	}
	return oRetVal;
}

long CComboBox::OnCompareItem(WPARAM wParam, LPARAM lParam)
{
	COMPAREITEMSTRUCT *pCompareItem = (COMPAREITEMSTRUCT *)lParam;
	return CompareItem(pCompareItem->itemID1, pCompareItem->itemData1,
			pCompareItem->itemID2, pCompareItem->itemData2);
}

long CComboBox::OnDeleteItem(WPARAM wParam, LPARAM lParam)
{
	DELETEITEMSTRUCT *pDeleteItem = (DELETEITEMSTRUCT *)lParam;
	return DeleteItem(pDeleteItem->itemID, pDeleteItem->itemData);
}

long CComboBox::OnDrawItem(WPARAM wParam, LPARAM lParam)
{
	DRAWITEMSTRUCT *pDrawItem = (DRAWITEMSTRUCT *)lParam;
	switch(pDrawItem->itemAction)
	{
		case ODA_DRAWENTIRE:
			return ODADrawEntire(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
		case ODA_SELECT:
			return ODASelect(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
		case ODA_FOCUS:
			return ODAFocus(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
	}

	return 0;
}

long CComboBox::OnMeasureItem(WPARAM wParam, LPARAM lParam)
{
	MEASUREITEMSTRUCT *pMeasureItem = (MEASUREITEMSTRUCT *)lParam;
	return MeasureItem(pMeasureItem->itemID, pMeasureItem->itemData,
			pMeasureItem->itemWidth, pMeasureItem->itemHeight);
}
//
//
//
//////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//
// CListBox
//
void CListBox::InitMsgHandlers()
{
	// initialize message handlers
	AddMsg(SWinMsg(WM_COMPAREITEM, (CWMSGHANDLER)CListBox::OnCompareItem));
	AddMsg(SWinMsg(WM_DELETEITEM, (CWMSGHANDLER)CListBox::OnDeleteItem));
	AddMsg(SWinMsg(WM_DRAWITEM, (CWMSGHANDLER)CListBox::OnDrawItem));
	AddMsg(SWinMsg(WM_MEASUREITEM, (CWMSGHANDLER)CListBox::OnMeasureItem));
}

long CListBox::OnCompareItem(WPARAM wParam, LPARAM lParam)
{
	COMPAREITEMSTRUCT *pCompareItem = (COMPAREITEMSTRUCT *)lParam;
	return CompareItem(pCompareItem->itemID1, pCompareItem->itemData1,
			pCompareItem->itemID2, pCompareItem->itemData2);
}

long CListBox::OnDeleteItem(WPARAM wParam, LPARAM lParam)
{
	DELETEITEMSTRUCT *pDeleteItem = (DELETEITEMSTRUCT *)lParam;
	return DeleteItem(pDeleteItem->itemID, pDeleteItem->itemData);
}

long CListBox::OnDrawItem(WPARAM wParam, LPARAM lParam)
{
	DRAWITEMSTRUCT *pDrawItem = (DRAWITEMSTRUCT *)lParam;
	switch(pDrawItem->itemAction)
	{
		case ODA_DRAWENTIRE:
			return ODADrawEntire(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
		case ODA_SELECT:
			return ODASelect(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
		case ODA_FOCUS:
			return ODAFocus(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
	}

	return 0;
}

long CListBox::OnMeasureItem(WPARAM wParam, LPARAM lParam)
{
	MEASUREITEMSTRUCT *pMeasureItem = (MEASUREITEMSTRUCT *)lParam;
	return MeasureItem(pMeasureItem->itemID, pMeasureItem->itemData,
			pMeasureItem->itemWidth, pMeasureItem->itemHeight);
}
//
//
//
//////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//
// CButton
//
void CButton::InitMsgHandlers()
{
	// initialize message handlers
	AddMsg(SWinMsg(WM_DRAWITEM, (CWMSGHANDLER)CButton::OnDrawItem));
	AddMsg(SWinMsg(WM_MEASUREITEM, (CWMSGHANDLER)CButton::OnMeasureItem));
}

long CButton::OnDrawItem(WPARAM wParam, LPARAM lParam)
{
	DRAWITEMSTRUCT *pDrawItem = (DRAWITEMSTRUCT *)lParam;
	switch(pDrawItem->itemAction)
	{
		case ODA_DRAWENTIRE:
			return ODADrawEntire(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
		case ODA_SELECT:
			return ODASelect(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
		case ODA_FOCUS:
			return ODAFocus(pDrawItem->itemID, pDrawItem->itemData,
					pDrawItem->itemState, CDC(pDrawItem->hDC), pDrawItem->rcItem);
	}

	return 0;
}

long CButton::OnMeasureItem(WPARAM wParam, LPARAM lParam)
{
	MEASUREITEMSTRUCT *pMeasureItem = (MEASUREITEMSTRUCT *)lParam;
	return MeasureItem(pMeasureItem->itemID, pMeasureItem->itemData,
			pMeasureItem->itemWidth, pMeasureItem->itemHeight);
}
//
//
//
//////////////////////////////////////////////////////////////

#ifdef __WINV40

//////////////////////////////////////////////////////////////
//
// CTabControl
//
int CTabControl::InsertTextItem(TCHAR *pszText, int nItem, HWND hTemplate)
{
	TC_ITEM Item;
	Item.mask = TCIF_TEXT | TCIF_PARAM;
	Item.pszText = pszText;
	Item.iImage = -1;
	Item.lParam = (LPARAM)hTemplate;
	return TabCtrl_InsertItem(HWindow, nItem, &Item);
}

int CTabControl::InsertImageItem(int nImage, int nItem, HWND hTemplate)
{
	TC_ITEM Item;
	Item.mask = TCIF_IMAGE | TCIF_PARAM;
	Item.iImage = nImage;
	Item.lParam = (LPARAM)hTemplate;
	return TabCtrl_InsertItem(HWindow, nItem, &Item);
}

int CTabControl::SelectTab(int nItem)
{
	int nRetVal = TabCtrl_SetCurSel(HWindow, nItem);
	int nTabCount = TabCtrl_GetItemCount(HWindow);
	for(int i=0;i<nTabCount;i++)
	{
		TC_ITEM Item;
		Item.mask = TCIF_PARAM;
		TabCtrl_GetItem(HWindow, i, &Item);
		if(Item.lParam)
		{
			if(i == nItem)
			{
				::ShowWindow((HWND)Item.lParam, SW_SHOW);
				::SetFocus((HWND)Item.lParam);
			}
			else
			{
				::ShowWindow((HWND)Item.lParam, SW_HIDE);
			}
		}
	}

	return nRetVal;
}

void CTabControl::SizeTemplates()
{
	RECT rcWindow = GetClientRect();
	TabCtrl_AdjustRect(HWindow, false, &rcWindow);
	int nTabCount = TabCtrl_GetItemCount(HWindow);
	for(int i=0;i<nTabCount;i++)
	{
		TC_ITEM Item;
		Item.mask = TCIF_PARAM;
		TabCtrl_GetItem(HWindow, i, &Item);
		if(Item.lParam)
			::MoveWindow((HWND)Item.lParam, rcWindow.left, rcWindow.top,
					rcWindow.right-rcWindow.left, rcWindow.bottom-
					rcWindow.top, false);
	}
}
//
//
//
//////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//
// CListView
//
int CListView::InsertTextColumn(TCHAR *pszText, int nCol, int nWidth)
{
	LV_COLUMN Column;
	
	ZeroMemory(&Column, sizeof(Column));
	
	Column.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	Column.fmt = LVCFMT_LEFT;
	Column.cx = nWidth;
	Column.pszText = pszText;
	Column.cchTextMax = -1;
	Column.iSubItem = nCol;
	
	return InsertColumn(nCol, &Column);
}

int CListView::InsertTextItem(TCHAR *pszText, int nItem, LPARAM lParam)
{
	LV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));
	
	Item.mask = LVIF_TEXT | LVIF_PARAM;
	Item.iItem = nItem;
	Item.pszText = pszText;
	Item.cchTextMax = -1;
	Item.iImage = -1;
	Item.lParam = lParam;
	
	return InsertItem(&Item);
}

int CListView::SetImage(int nItem, int aImageIdex)
{
	LV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));
	
	Item.mask = LVIF_IMAGE;
	Item.iItem = nItem;
	Item.iImage = aImageIdex;
	
	return SetItem(&Item);
}


long CListView::GetItemData(int nItem)
{
	LV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));
	
	Item.iItem = nItem;
	Item.mask = LVIF_PARAM;
	GetItem(&Item);
	
	return Item.lParam;
}

void CListView::SetItemData(int nItem, long lData)
{
	LV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));
	
	Item.iItem = nItem;
	Item.mask = LVIF_PARAM;
	Item.lParam = lData;
	SetItem(&Item);
}

void CListView::InitMsgHandlers(void)
{
	AddMsg(SWinMsg(WM_LBUTTONDBLCLK , (CWMSGHANDLER)CListView::OnWmLButtonDblclk));
}


void CListView::OnLButtonDblclk(int fwKeys, int aX, int aY)
{
	LV_HITTESTINFO	hitTest;

	hitTest.pt.x = aX; 
	hitTest.pt.y = aY; 

	if (HitTest(&hitTest) >= 0)
	{
		if ((hitTest.flags & (LVHT_ONITEMLABEL | LVHT_ONITEMICON)))
			::PostMessage(GetParent(), WM_USER_ITEM_DBLCLICKED, hitTest.iItem, 0);
	}
}


int CListView::GetFirstSelectedItem()
{
	int			Count = GetItemCount();

	for (int i=0 ; i<Count ; i++)
	{
		if (GetItemState(i, LVIS_FOCUSED) == LVIS_FOCUSED)
		{
			return i;
		}
	}
	return -1;
}
//
//
//
//////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////
//
// CTreeView
//
BOOL CTreeView::GetItemText(HTREEITEM hItem, TCHAR *pszText, int nTextMax)
{
	TV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));

	Item.hItem = hItem;
	Item.mask = TVIF_TEXT;
	Item.pszText = pszText;
	Item.cchTextMax = nTextMax;

	return GetItem(&Item);
}

HTREEITEM CTreeView::InsertTextItem(TCHAR *pszText, HTREEITEM hParent,
		HTREEITEM hAfter, LPARAM lParam)
{
	TVINSERTSTRUCT tvi;
	
	ZeroMemory(&tvi, sizeof(tvi));
	
	tvi.item.mask = TVIF_TEXT | TVIF_PARAM;
	tvi.item.pszText = pszText;
	tvi.item.cchTextMax = -1;
	tvi.item.iImage = -1;
	tvi.item.lParam = lParam;

	tvi.hParent = hParent;
	tvi.hInsertAfter = hAfter;
	
	return InsertItem(&tvi);
}

long CTreeView::GetItemData(HTREEITEM hItem)
{
	TV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));
	
	Item.hItem = hItem;
	Item.mask = TVIF_PARAM;
	GetItem(&Item);
	
	return Item.lParam;
}

void CTreeView::SetItemData(HTREEITEM hItem, long lData)
{
	TV_ITEM Item;
	
	ZeroMemory(&Item, sizeof(Item));
	
	Item.hItem = hItem;
	Item.mask = TVIF_PARAM;
	Item.lParam = lData;
	SetItem(&Item);
}
//
//
//
//////////////////////////////////////////////////////////////

#include <string.h>

//////////////////////////////////////////////////////////////
//
// CRichEdit
//
DWORD CALLBACK EditReadStreamCallback(DWORD dwCookie, LPBYTE pbBuffer,
		long lCount, long *plBytesRead)
{
	return (DWORD)((CRichEdit *)dwCookie)->Read(pbBuffer, lCount, plBytesRead);
}

DWORD CALLBACK EditWriteStreamCallback(DWORD dwCookie, LPBYTE pbBuffer,
		long lCount, long *plBytesWritten)
{
	return (DWORD)((CRichEdit *)dwCookie)->Write(pbBuffer, lCount, plBytesWritten);
}

unsigned long CRichEdit::Read(unsigned char *pbBuffer, long lCount,
		long *plBytesRead)
{
	if(m_pText)
	{
		if(m_nTextCount + lCount > (int)strlen(m_pText))
			lCount = strlen(m_pText) - m_nTextCount;
		*plBytesRead = lCount;
		CopyMemory(pbBuffer, &m_pText[m_nTextCount], lCount);
		m_nTextCount += lCount;
	}
	else
		*plBytesRead = 0;

	return 0L;
}

unsigned long CRichEdit::Write(unsigned char *pbBuffer, long lCount,
		long *plBytesWritten)
{
/*	if(m_pText)
	{
		if(m_nTextCount + lCount > strlen(m_pText))
			lCount = strlen(m_pText) - m_nTextCount;
		*plBytesRead = lCount;
		CopyMemory(pbBuffer, &m_pText[m_nTextCount], lCount);
		m_nTextCount += lCount;
	}
	else
		*plBytesRead = 0;
*/
	return 1L;
}

void CRichEdit::SetText(const char *pszText)
{
	m_pText = pszText;
	m_nTextCount = 0;

	EDITSTREAM EditStream;
	EditStream.dwCookie = (DWORD)this;
	EditStream.pfnCallback = EditReadStreamCallback;
	EditStream.dwError = 0;
	
	SendMessage(EM_STREAMIN, SF_TEXT, (LPARAM)&EditStream);
	SendMessage(EM_SETMODIFY, TRUE);
}

void CRichEdit::SetRTFText(const char *pszText)
{
	m_pText = pszText;
	m_nTextCount = 0;

	EDITSTREAM EditStream;
	EditStream.dwCookie = (DWORD)this;
	EditStream.pfnCallback = EditReadStreamCallback;
	EditStream.dwError = 0;
	
	SendMessage(EM_STREAMIN, SF_RTF, (LPARAM)&EditStream);
	SendMessage(EM_SETMODIFY, TRUE);
}
//
//
//
//////////////////////////////////////////////////////////////

#endif	//__WINV40
