/*******************************************************************
 *
 *	File:		CDeskwinApp.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include "Deskwin.h"
#include "CDeskwinWindow.h"
#include "CDeskwinEngine.h"
#include "commctrl.h"

static BOOL AmITheFirst()
{
	HANDLE hMutex = CreateMutex (NULL, TRUE, "Deskwin");
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
	   CloseHandle(hMutex);
	   return FALSE;
	}
	return TRUE;
}


class CDeskWinApp : public CApplication
{
public:
	virtual ~CDeskWinApp();

protected:
	virtual bool Initialize();

	CDeskwinEngine*		iDeskwinEngine;
	CDeskwinWindow		*iDeskwinWindow;
};


CDeskWinApp::~CDeskWinApp()
{
	delete iDeskwinWindow;
	iDeskwinWindow = NULL;

	delete iDeskwinEngine;
	iDeskwinEngine = NULL;
}

bool CDeskWinApp::Initialize()
{
	InitCommonControls();

	if (!AmITheFirst())
	{
		::MessageBox(NULL, "Deskwin is already running", "Deskwin", MB_ICONSTOP); 
		return false;
 	}

	iDeskwinEngine = CDeskwinEngine::Instance();

	iDeskwinWindow = new CDeskwinWindow();
	AddWindow(iDeskwinWindow);
	iDeskwinWindow->Construct(iDeskwinEngine);

	return true;
}


CDeskWinApp g_MyApp;



/*******************************************************************
 *
 * $Log: /Deskwin/Src/CDeskwinApp.cpp $
 * 
 * 4     10/01/00 9:17 Pese
 * 
 * 3     5/01/00 20:26 Pese
 * 
 * 2     23/12/99 10:16 Pese
 *
 *******************************************************************/
