/*******************************************************************
 *
 *	File:		CHyperLinkText.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include "Deskwin.h"

#define LO_INT16(dw) ((short) (dw & 0xffff))
#define HI_INT16(dw) ((short) (dw >> 16))


class CHyperLinkText : public CWindowEx
{
public:
	CHyperLinkText(HWND aStaticWindow, COLORREF aColor = ct_LightBlue, COLORREF aBgColor = ct_LightGray);
	~CHyperLinkText();

	enum THorAlignmen
	{
		EHorLeft,
		EHorRight,
		EHorCenter
	};

	enum TVertAlignment
	{
		EVertTop,
		EVertBottom,
		EVertCenter
	};
	void SetWindowText(CDC& aDc, const char* aText, int aTextLen);


protected:
	virtual LRESULT Dispatch(unsigned int nMessage, WPARAM wParam, LPARAM lParam);

	void InitMessageHandlers();
	long OnWmLButtonDown(WPARAM aWParam, LPARAM aLParam){OnLButtonDown(aWParam, LO_INT16(aLParam), HI_INT16(aLParam)); return 1;}
	long OnWmLButtonUp(WPARAM aWParam, LPARAM aLParam){OnLButtonUp(aWParam, LO_INT16(aLParam), HI_INT16(aLParam)); return 1;}
	long OnWmMouseMove(WPARAM aWParam, LPARAM aLParam){OnMouseMove(aWParam, LO_INT16(aLParam), HI_INT16(aLParam)); return 1;}

	void OnLButtonDown(int fwKeys, int aX, int aY);
	void OnLButtonUp(int fwKeys, int aX, int aY);
	void OnMouseMove(int fwKeys, int aX, int aY);
	void Paint(CDC& aDc);

	void DoHyperLink();

protected:
	COLORREF		iFgColor;
	HCURSOR			iCursor;
	CFont			iFont;
	CFont			iSelectedFont;
	bool			iSelected;

	RECT			iRect;
	THorAlignmen	iHorAlignment;
	TVertAlignment	iVertAlignment;
};	


