/*******************************************************************
 *
 *	File:		CSmoothWindowMover.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __CSMOOTH_WINDOW_MOVER_H
#define __CSMOOTH_WINDOW_MOVER_H

class MSmoothWindowMoverObserver
{
protected:
	virtual void DoneSmoothWindowMoving(CWindow* aWindow) = 0;
friend class CSmoothWindowMover;
};


class CSmoothWindowMover
{
public:
	CSmoothWindowMover();
	virtual ~CSmoothWindowMover();

	SetOptions(int aAnimationStepTime);

	void StartSmoothMoving(CWindow* aWindow, int aDeltaX, int aDeltaY, int aAnimationTime, int aAnimationStepTime, MSmoothWindowMoverObserver* aObserver);
	void StopSmoothMoving();
	bool IsSmoothMoving() {return (iAnimationStep != -1);}


protected:
	void	DoAnimationStep();
	static	void CALLBACK AnimationTimer(HWND aWindow, UINT aMsg, UINT aEventId, DWORD aTime); 
 
	POINT							iWindowSize;
	POINT							iAnimationStepMove;
	int								iNoOfAnimationSteps;
	int								iAnimationStep;
	int								iAnimationTime;
	int								iAnimationStepTime;

	CWindow*						iWindow;
	MSmoothWindowMoverObserver*		iObserver;
};

/*******************************************************************
 *
 * $Log: /Deskwin/Src/CSmoothWindowMover.h $
 * 
 * 4     10/01/00 9:17 Pese
 * 
 * 3     5/01/00 20:26 Pese
 * 
 * 2     23/12/99 10:16 Pese
 *
 *******************************************************************/


#endif			/* __CSMOOTH_WINDOW_MOVER_H */