/*******************************************************************
 *
 *	File:		CSysTrayIconController.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __CSYS_TRAY_ICON_CONTROLLER_H
#define __CSYS_TRAY_ICON_CONTROLLER_H

#include "MDesktopEngineObserver.h"
#include "TDeskwinOptions.h"

class CSysTrayIconController : public CWindowEx, public MDesktopEngineObserver
{
public:
	CSysTrayIconController(HWND aSysTrayEventHandler, UINT aSysTrayEvent);
	~CSysTrayIconController();
	void Construct();
	void OptionsChanged(const TSysTrayIconOptions& iSysTrayIconOptions);

public:		// implements MDesktopEngineObserver
	virtual void HandleDesktopChanged(int aOldDesktop, int aNewDesktop);

protected:
	void OnSysTrayEvent(WPARAM wParam, LPARAM lParam);
	void RemoveIcon();
	void SetIcon();

	TSysTrayIconOptions		iSysTrayIconOptions;
	HICON		iIcon;
	int			iCurrentDesktop;
	bool		iIconAdded;

	NOTIFYICONDATA	iNotifyIconData;
	HWND			iSysTrayEventHandler;
	UINT			iSysTrayEvent;
};

#endif			/* __CSYS_TRAY_ICON_CONTROLLER_H */
