/*******************************************************************
 *
 *	File:		CWindowPositionTracker.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __CWINDOW_POSITION_TRACKER_H
#define __CWINDOW_POSITION_TRACKER_H

typedef struct
{
	TWindow		iWindow;
	RECT		iPosition;
} TWindowPosInfo;
typedef vector<TWindowPosInfo>	TWindowPosInfos;


class CWindowPositionTracker
{
public:
	CWindowPositionTracker();

		/*
		 * only the public methods run in the context of the caller's
		 * thread
		 */
	virtual ~CWindowPositionTracker();
	void StartWindowPositionTracking(TWindow aWindowToReportTo, int aMessageToReport, int aActiveTrackingTime, int aBackgroundTrackingTime);
	void PauseWindowPositionTracking();
	void ResumeWindowPositionTracking();
	void StopWindowPositionTracking();

protected:
	bool IsThreadRunning() {return iPrivateThread != 0;}
	static void KickoffWindowTracker(void*);
	void DoTheWindowTracking();
	void TakeSnapShot(TWindowPosInfos& aWindowPosInfo);
	bool AreSnapshotsDifferent(TWindowPosInfos& aWindowPosInfo1, TWindowPosInfos& aWindowPosInfo2);

protected:
	TWindow				iReportWindow;
	UINT				iReportMessage;
	int					iActiveTrackingTime;
	int					iBackgroundTrackingTime;
	
	bool				iIsFastTracking;
	
	HANDLE				iPauseEvent;
	HANDLE				iStopEvent;
	HANDLE				iPrivateThread;
};

/*******************************************************************
 *
 * $Log: /Deskwin/Src/CWindowPositionTracker.h $
 * 
 * 4     10/01/00 9:17 Pese
 * 
 * 3     5/01/00 20:26 Pese
 * 
 * 2     23/12/99 10:16 Pese
 *
 *******************************************************************/


#endif			/* __CWINDOW_POSITION_TRACKER_H */