/*******************************************************************
 *
 *	File:		Regutil.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/


#ifndef __REGUTIL_H
#define __REGUTIL_H

#ifdef __cplusplus
extern "C" {
#endif			/* __cplusplus */


long StartIterateRegSubkeys(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	const _TCHAR		*ValueName,
	OUT	 _TCHAR				*StringValue,
	IN	OUT int				*StringValueLen
	);

long GetRegKeyStringValue(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	const _TCHAR		*ValueName,
	OUT	 _TCHAR				*StringValue,
	IN	OUT int				*StringValueLen
	);

long GetRegKeyIntegerValue(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	const _TCHAR		*ValueName,
	OUT	int					*IntegerValue
	);

long GetRegKeyUintValue(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	const _TCHAR		*ValueName,
	OUT	unsigned int		*UintValue
	);

long SetRegKeyStringValue(
	IN	HKEY					RootKey,
	IN	const _TCHAR			*KeyName,
	IN	const _TCHAR			*ValueName,
	IN	const _TCHAR			*StringValue
	);

long SetRegKeyIntegerValue(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	const _TCHAR		*ValueName,
	IN	int					IntegerValue
	);

long SetRegKeyUintValue(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	const _TCHAR		*ValueName,
	OUT	unsigned int		UintValue
	);


long DestroyRegKeyStringValue(
	IN	HKEY					RootKey,
	IN	const _TCHAR			*KeyName,
	IN	const _TCHAR			*ValueName
	);

long DestroyRegKey(
	IN	HKEY					RootKey,
	IN	const _TCHAR			*KeyName,
	IN	const _TCHAR			*SubKeyName
	);

long CreateRegKey(
	IN	HKEY					RootKey,
	IN	const _TCHAR			*KeyName,
	IN	const _TCHAR			*SubKeyName
	);

long EnumRegKey(
	IN	HKEY				RootKey,
	IN	const _TCHAR		*KeyName,
	IN	int					Index,
	OUT	_TCHAR				*SubKeyName,
	OUT	int					SubKeyNameLen
	);

#ifdef __cplusplus
}
#endif			/* __cplusplus */


#endif			/* __REGUTIL_H */
