/*******************************************************************
 *
 *	File:		TDeskwinOptions.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef ___TDESKWIN_OPTIONS
#define ___TDESKWIN_OPTIONS

#include "TStickyWindow.h"

typedef unsigned int		THotkey;
typedef vector<THotkey>		THotkeyList;

void MakeWParmHotkeyMessage(THotkey aHotkey, WORD& aWParm);
void MakeHotkeyFromWParamMessage(THotkey& aHotkey, WORD aWParm);
void MakeRegisterHotkeyParam(THotkey aHotkey, int& aVk, int& aMod);


#define OPTION_NO_OF_DESKTOPS_HOR				_T("NoOfDesktopsHor")
#define OPTION_NO_OF_DESKTOPS_VERT				_T("NoOfDesktopsVert")
#define OPTION_DESKTOP_PIXEL_WIDTH				_T("DesktopPixelWidth")
#define OPTION_DESKTOP_PIXEL_HEIGHT				_T("DesktopPixelHeight")

#define OPTION_COLSIZE_ROOT						REG_OPTION_ROOT _T("\\") _T("Color And Sizes")
#define OPTION_DESKTOP_OUT_FRAME_PIXEL_SIZE		_T("DesktopOutFramePixelSize")
#define OPTION_DESKTOP_IN_FRAME_PIXEL_SIZE		_T("DesktopInFramePixelSize")

#define OPTION_OUTER_FRAME_COLOR				_T("OuterFrameColor")
#define OPTION_INNER_FRAME_COLOR				_T("InnerFrameColor")
#define OPTION_BACK_GROUND_COLOR				_T("BackgroundFrameColor")
#define OPTION_ACTIVE_DESKTOP_COLOR				_T("ActiveDesktopColor")
#define OPTION_WINDOW_FRAME_COLOR				_T("WindowFrameColor")
#define OPTION_WINDOW_COLOR						_T("WindowColor")

/*
 * Docking info
 */
#define OPTION_DOCKING_ROOT						REG_OPTION_ROOT _T("\\")  _T("Docking")
#define OPTION_WANT_DOCKING						_T("WantDocking")
#define OPTION_DOCK_PERCENT_FROM_EDGE			_T("DockPercentFromEdge")

#define OPTION_AUTOHIDE_ROOT					REG_OPTION_ROOT _T("\\")  _T("AutoHide")
#define OPTION_AUTO_HIDE						_T("WantAutoHide")
#define OPTION_SHOW_BY_MOUSE_CLICK				_T("WantShowByMouseClick")
#define OPTION_PERCENT_VISIBLE					_T("PercentVisible")
#define OPTION_AUTO_HIDE_TIMEOUT				_T("AutoHideTimeOut")
#define OPTION_ANIMATION_TIME					_T("AnimationTime")
#define OPTION_ANIMATION_STEP_TIME				_T("AnimationStepTime")

/*
 * Window position tracking
 */
#define OPTION_WINPOS_TRACKING_ROOT				REG_OPTION_ROOT _T("\\")  _T("PositionTracking")
#define OPTION_ACTIVE_POSITION_TRACKING_TIME	_T("ActivePositionTrackingTime")
#define OPTION_PASSIVE_POSITION_TRACKING_TIME	_T("PassivePositionTrackingTime")

/*
 * Hotkeys
 */
#define OPTION_HOTKEY_ROOT						REG_OPTION_ROOT _T("\\")  _T("Hotkeys")
#define OPTION_HOTKEY_DESKTOP_BASE				_T("Desktop")
#define OPTION_HOTKEY_SHOW_DESKWIN				_T("ShowDeskwin")
#define OPTION_HOTKEY_NEXT						_T("NextDesktop")
#define OPTION_HOTKEY_PREVIOUS					_T("PreviousDesktop")
#define OPTION_HOTKEY_UP						_T("DesktopUp")
#define OPTION_HOTKEY_DOWN						_T("DesktopDown")
#define OPTION_HOTKEY_TOGGLE_EXPLORER			_T("ToggleExplorer")
#define OPTION_HOTKEY_MINIMISE_ALL				_T("MinimiseAll")
#define OPTION_HOTKEY_VOLUME_TOGGLE_MUTE		_T("VolumeToggleMute")
#define OPTION_HOTKEY_VOLUME_UP					_T("VolumeUp")
#define OPTION_HOTKEY_VOLUME_DOWN				_T("VolumeDown")

 /*
 * Window state info
 */
#define OPTION_STATE_ROOT						REG_OPTION_ROOT _T("\\") _T("WindowState")
#define STATE_DOCKING_PLACE						_T("DockingPlace")
#define STATE_POSITION_X						_T("PositionX")
#define STATE_POSITION_Y						_T("PositionY")

/*
 * Stikcy windows
 */
#define OPTION_STICKY_ROOT						REG_OPTION_ROOT _T("\\") _T("StickyWindows")
#define STICKY_TITLE_NAME						_T("Title")
#define STICKY_CLASS_NAME						_T("ClassName")
#define STICKY_DESKTOP_STATE					_T("DesktopState")
#define STICKY_RULE_MATCH						_T("RuleMatch")
#define STICKY_DESKTOP_LIST						_T("DesktopList")

/*
 * Appearance
 */
#define OPTION_APPEARANCE_ROOT					REG_OPTION_ROOT _T("\\")  _T("Appearance")
#define OPTION_APPEARANCE_ALWAYS_ON_TOP			_T("AlwaysOnTop")
#define OPTION_APPEARANCE_ICONSET				_T("IconSet")
#define OPTION_APPEARANCE_ICON_TRANSPARENT		_T("IconTransparentBackground")
#define OPTION_APPEARANCE_ICON_FG_COLOR			_T("IconForegroundColor")
#define OPTION_APPEARANCE_ICON_BG_COLOR			_T("IconBackgroundColor")


#define MIN_NO_OF_DESKTOPS		1
#define MAX_NO_OF_DESKTOPS		10

#define MIN_DESKTOP_PIXEL_SIZE	5
#define MAX_DESKTOP_PIXEL_SIZE	1000

#define MIN_OUT_FRAME_PIXEL_SIZE	2
#define MAX_OUT_FRAME_PIXEL_SIZE	100

#define MIN_IN_FRAME_PIXEL_SIZE	1
#define MAX_IN_FRAME_PIXEL_SIZE	100

#define MIN_DOCK_PERCENT_FROM_EDGE	1
#define MAX_DOCK_PERCENT_FROM_EDGE	45

#define MIN_PERCENT_VISIBLE			1
#define MAX_PERCENT_VISIBLE	100

#define MIN_AUTO_HIDE_TIMEOUT	500
#define MAX_AUTO_HIDE_TIMEOUT	100000

#define MIN_ANIMATION_TIME	0
#define MAX_ANIMATION_TIME	10000

#define MIN_ANIMATION_STEP_TIME	0
#define MAX_ANIMATION_STEP_TIME	10000

#define MIN_ACTIVE_POSITION_TRACKING_TIME	10
#define MAX_ACTIVE_POSITION_TRACKING_TIME	10000

#define MIN_BACKGROUND_POSITION_TRACKING_TIME	10
#define MAX_BACKGROUND_POSITION_TRACKING_TIME	10000


#define MAX_SYS_TRAY_ICON_SETS	3


typedef struct _TSysTrayIconOptions
{
	int					iIconSet;
	bool				iTransparentBackground;
	COLORREF			iFgColor;
	COLORREF			iBgColor;
} TSysTrayIconOptions;


typedef struct _TDeskwinOptions
{
	bool				iWantsDocking;
	int					iDockPercentFromEdge;

	bool				iWantsAutoHide;
	bool				iWantsShowByMouseClick;
	int					iPercentVisible;
	int					iAutoHideTimeOut;
	int					iAnimationTime;
	int					iAnimationStepTime;

	int					iSnapResizePercent;

	int					iNoOfDesktopsHor;
	int					iNoOfDesktopsVert;

	int					iDesktopPixelWidth;
	int					iDesktopPixelHeight;

	int					iActivePositionTrackingTime;
	int					iBackgroundPositionTrackingTime;

	int					iDesktopOutFramePixelSize;
	int					iDesktopInFramePixelSize;

	COLORREF			iOuterFrameColor;
	COLORREF			iInnerFrameColor;
	COLORREF			iBackgroundColor;
	COLORREF			iActiveDesktopColor;
	COLORREF			iWindowFrameColor;
	COLORREF			iWindowColor;

	THotkeyList			iHotkeyList;
	THotkey				iHotkeyShowDeskwin;
	THotkey				iHotkeyNextDesktop;
	THotkey				iHotkeyPreviousDesktop;
	THotkey				iHotkeyDesktopUp;
	THotkey				iHotkeyDesktopDown;
	THotkey				iHotkeyToggleExplorer;
	THotkey				iHotkeyMinimiseAll;
	THotkey				iHotkeyVolumeToggleMute;
	THotkey				iHotkeyVolumeUp;
	THotkey				iHotkeyVolumeDown;


	TStickyWindowInfo	iStickyWindowInfo;

		/*
		 * Appearance
		 */
	bool				iAlwaysOnTop;
	TSysTrayIconOptions	iSysTrayIconOptions;
} TDeskwinOptions;


void CopyOptions(const TDeskwinOptions& aSrcOptions, TDeskwinOptions& aDstOptions);
void SaveOptions(TDeskwinOptions& aOptions);
void LoadOptions(TDeskwinOptions& aOptions);

/*******************************************************************
 *
 * $Log: /Deskwin/Src/TDeskwinOptions.h $
 * 
 * 4     10/01/00 9:17 Pese
 * 
 * 3     5/01/00 20:26 Pese
 * 
 * 2     23/12/99 10:16 Pese
 *
 *******************************************************************/


#endif			/* ___TDESKWIN_OPTIONS */
