/*******************************************************************
 *
 *	File:		TStickyWindow.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef ___TSTICKY_WINDOW_H
#define ___TSTICKY_WINDOW_H

enum TStickyWindowDesktop	{ EStickyWindowDesktopAll=0, EStickyWindowDesktopInclude, EStickyWindowDesktopExclude};
enum TStickyWindowMatch {	EStickyWindowMatchAnd = 0, EStickyWindowMatchOr, };

typedef list<int>		TDesktopList;

class TStickyWindow
{
public:
	string					iRuleName;
	string					iClassName;
	string					iTitleName;
//	vector<int>				iDesktopList;
	TDesktopList			iDesktopList;
	TStickyWindowDesktop	iStickyWindowDesktop;
	TStickyWindowMatch		iStickyWindowMatch;
	TStickyWindow() : iStickyWindowDesktop(EStickyWindowDesktopAll), iStickyWindowMatch(EStickyWindowMatchAnd) {}
};

typedef vector<TStickyWindow>	TStickyWindowInfo;

bool operator <(const TStickyWindow& aStickyWindow1, const TStickyWindow& aStickyWindow2);
bool operator ==(const TStickyWindow& aStickyWindow1, const TStickyWindow& aStickyWindow2);


#endif			/* ___TSTICKY_WINDOW_H */
