/*******************************************************************
 *
 *	File:		Debug.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __DEBUG_H
#define __DEBUG_H

#ifdef _DEBUG

void __cdecl _dprint(char* Fmt, ...);

#if 0
#define STRLNX(x) #x
#define HEREX(line) __FILE__ "(" STRLNX(line) ") : "
#define HERE HEREX(__LINE__)
#endif

#define HERE2(l) #l
#define HERE1(l) HERE2(l)
#define HERE __FILE__ "(" HERE1(__LINE__) ") : "

#define DPRINT(x) _dprint x

#undef ASSERT
#define ASSERT(x)					\
	{								\
		if (!(x))					\
			_asm int 3				\
	}






#else

#define ASSERT(x)
#define DPRINT(x)



#endif			/* _DEBUG */

/*******************************************************************
 *
 * $Log: /Deskwin/Src/debug.h $
 * 
 * 4     10/01/00 9:17 Pese
 * 
 * 3     5/01/00 20:26 Pese
 * 
 * 2     23/12/99 10:16 Pese
 *
 *******************************************************************/


#endif			/* __DEBUG_H */